#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <zombiereloaded>

#define	PLUGIN_VERSION "1.2"

new Handle:g_hDisplayHandle[MAXPLAYERS+1] = INVALID_HANDLE;

new g_iHumanCount, g_iZombieCount;

new bool:g_bStatus;
new bool:g_bIsVoteGoingOn;

public Plugin:myinfo =
{
	name 		=		"[ZR] Humans/Zombies/HP Left Display",
	author		=		"d0ck3r", 
	description	=		"", 
	version		=		PLUGIN_VERSION,
	url			=		"http://hlmod.ru/"
};

public OnPluginStart()
{
	CreateConVar("zr_humanzombiehpdisplay_version", PLUGIN_VERSION, "Version of the plugin", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	HookEvent("player_death",		ReCountEvent,		EventHookMode_Post);
	HookEvent("player_spawn", 		ReCountEvent,		EventHookMode_Post);
	HookEvent("player_team", 		ReCountEvent,		EventHookMode_Post);
	HookEvent("player_disconnect", 	ReCountEvent,		EventHookMode_Post);
	HookEvent("player_hurt",		Event_PlayerHurt,	EventHookMode_PostNoCopy);
	HookEvent("round_start", 		Event_RoundStart,	EventHookMode_PostNoCopy);
	
	CreateTimer(1.0, CheckIfVoteIsOccuring, _, TIMER_REPEAT);
	
	LoadTranslations("zr_humanzombiehpdisplay.phrases");
}

public OnPluginEnd()
{
	UnhookEvent("player_death",			ReCountEvent,		EventHookMode_Post);
	UnhookEvent("player_spawn", 		ReCountEvent,		EventHookMode_Post);
	UnhookEvent("player_team", 			ReCountEvent,		EventHookMode_Post);
	UnhookEvent("player_disconnect", 	ReCountEvent,		EventHookMode_Post);
	UnhookEvent("player_hurt",			Event_PlayerHurt,	EventHookMode_PostNoCopy);
	UnhookEvent("round_start", 			Event_RoundStart,	EventHookMode_PostNoCopy);
}

public OnMapEnd()
{
	for (new i; i <= MaxClients; i++)
	{
		if (g_hDisplayHandle[i] != INVALID_HANDLE)
		{
			KillTimer(g_hDisplayHandle[i]);
			g_hDisplayHandle[i] = INVALID_HANDLE;
		}
	}
}

public OnClientPutInServer(client)
{
	if (!IsFakeClient(client))
	{
		g_hDisplayHandle[client] = CreateTimer(5.0, PrintInformation, client, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
	}
}

public OnClientDisconnect(client)
{
	if (g_hDisplayHandle[client] != INVALID_HANDLE)
	{
		KillTimer(g_hDisplayHandle[client]);
		g_hDisplayHandle[client] = INVALID_HANDLE;
	}
}

public Action:CheckIfVoteIsOccuring(Handle:timer)
{
	g_bIsVoteGoingOn = IsVoteInProgress();
	
	return Plugin_Continue;
}

public Action:PrintInformation(Handle:timer, any:client)
{
	if (!g_bIsVoteGoingOn)
	{
		if (IsPlayerAlive(client))
		{
			switch (g_bStatus)
			{
				case 0:
				{
					PrintHintText(client, "%t", "To Infection", GetClientHealth(client), g_iHumanCount + g_iZombieCount);
				}
		
				case 1:
				{
					PrintHintText(client, "%t", "After Infection", GetClientHealth(client), g_iHumanCount, g_iZombieCount);
				}
			}
		}
		else
		{
			switch (g_bStatus)
			{
				case 0:
				{
					PrintHintText(client, "%t", "To Infection Spec", g_iHumanCount + g_iZombieCount);
				}
		
				case 1:
				{
					PrintHintText(client, "%t", "After Infection Spec", g_iHumanCount, g_iZombieCount);
				}
			}
		}
	}
	
	return Plugin_Continue;
}

public Action:Event_PlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (!g_bIsVoteGoingOn)
	{
		if (IsPlayerAlive(client))
		{
			switch (g_bStatus)
			{
				case 0:
				{
					PrintHintText(client, "%t", "To Infection", GetClientHealth(client), g_iHumanCount + g_iZombieCount);
				}
		
				case 1:
				{
					PrintHintText(client, "%t", "After Infection", GetClientHealth(client), g_iHumanCount, g_iZombieCount);
				}
			}
		}
	}
}

public Action:ReCountEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	ReCount();
}

public ZR_OnClientInfected(client, attacker, bool:motherInfect, bool:respawnOverride, bool:respawn)
{
	if (!g_bStatus)
	{
		g_bStatus = true;
	}
	
	ReCount();
}

public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bStatus)
	{
		g_bStatus = false;
	}
}

public ReCount()
{
	g_iHumanCount = 0;
	g_iZombieCount = 0;
	
	for (new i = 1; i <= MaxClients; i++)
	{	
		if (IsValidClient(i))
		{
			switch (GetClientTeam(i))
			{
				case 2:
				{
					g_iZombieCount++;
				}
				
				case 3:
				{
					g_iHumanCount++;
				}
			}
		}
	}
}

stock bool:IsValidClient(client)
{
	if (client > 0 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && IsPlayerAlive(client))
	{
		return true;
	}
	return false;
}